*************************************************************************
*  FTP Services for Visual Foxpro 5.0+                                  *
*  Written by: Robert Abram                                             *
*  Date: Sept 1998                                                      *
*                                                                       *
*  Revision 2.0                                                         *
*                                                                       *
*  Proxy Support                                                        *
*  Paul Culbertson                                                      *
*  http://www.foxite.com/archives/progress_bar_for_ftps_0000013728.htm  *
*                                                                       *
*                                                                       *
*  RESUME Support                                                       *
*  Zintis Petersons                                                     *
*  http://www.vbip.com/wininet/wininet-ftp-command-01.asp               *
*                                                                       *
*                                                                       *
*  Revision 1.1a                                                        *
*                                                                       *
*  wininet.dll needs to be in the windows/system                        *
*  directory.                                                           *
*                                                                       *
*  Updated 3/16/99 - Changed Date Usage to comply with                  *
*                    Strict Date handling.                              *
*														                *
*  Added 3/16/99 Functions - AutoDialInternet                           *
*                            AutoDialHangUp                             *
*                            DialInternet                               *
*                            DialHangUp                                 *
*                            GetConnectedState                          *
*                            GoOnline                                   *
*************************************************************************

#INCLUDE "FTP.h"

****************************************************
* Class Ftp_Service                                *
****************************************************
DEFINE CLASS FTP_SERVICE AS custom
   PROTECTED lDLL_Loaded

   cIPAddress 	        = ""
   cUserName           = ""
   cPassword           = ""
   cPort				= "21"     && Default FTP PORT
		
   nInet_Handle 		= 0
   nConnect_Handle 	= 0
   lDLL_Loaded 		= .F.
   nResult_Code		= 0
   nExtended_Result    = 0
   cExtended_Message   = ""
   cCurrentDir			= ""
		
   nCachingType        = INTERNET_FLAG_DONT_CACHE
		
   cAgent 				= "Visual FoxPro" + cNULL

   nFlags             = INTERNET_FLAG_PASSIVE && Default pasive mode
   lMultiOperations  = .T.
   cStartupFolder    = ""

   cProxyProtocol=""  && Protocol for proxy
   cProxyHost=""      && Proxyhost
   cProxyport=""      && ProxyPort
   lUseProxy = .F.
 
				
   ****************************************************
   PROTECTED PROCEDURE Init
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      IF _DOS OR _UNIX OR _MAC
         RETURN .F.
      ENDIF
   ENDPROC	
	
   ****************************************************
   PROTECTED PROCEDURE LoadAPIFuncs
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      * Variables need for defines
      LOCAL lpcAgent, nAccessType, lpcProxyName, lpcProxyBypass, nFlags,;
            nInet_Handle, nConnect_Handle, lpcServer, nPort, lpcUserName,;
            lpcPassword, nService, nContext, nMax_Path,;
            lpcDirectory, lpcFileName, lpcSearchStr, lpcWIN32_FIND_DATA,;
            lpcRemoteFile, lpcNewFile, nFailIfExists, nAttributes,;
            nError, lpcBuffer, nHandle, lpcDialUp

      * Check to see if We have already declared functions and loaded the DLL
      IF This.lDLL_Loaded  
         RETURN ERROR_SUCCESS
      ENDIF
		   	
      * Declare a Kernel32 Functions
      DECLARE Integer GetLastError IN Kernel32

      DECLARE Integer FileTimeToSystemTime IN Kernel32 ;
              String @lpcBuffer, String @lpcBuffer
		   
      * Declare DLL functions used by Program
      DECLARE Integer InternetAutodial IN WinInet ;
              Integer nAccessType, Integer nHandle
		   		
      DECLARE Integer InternetAutodialHangup IN WinInet ;
              Integer nFlags
		   			
      DECLARE Integer InternetDial IN WinInet ;
              Integer nHandle, String @lpcDialUp, Integer nAccessType, Integer @nConnect_Handle, ;
              Integer nFlags
		   	
      DECLARE Integer InternetHangUp IN WinInet ;
              Integer nConnect_Handle, Integer nFlags
		   			
      DECLARE Integer InternetGetConnectedState IN WinInet ;
              Integer @nContext, Integer nFlags
		   			
      DECLARE Integer InternetGoOnline IN WinInet ;
              String @lpcURL, Integer nHandle, Integer nFlags
		   			
      DECLARE Integer InternetOpen IN WinInet ;
              String @lpcAgent, Integer nAccessType, String @lpcProxyName, ;
              String @lpcProxyBypass, Integer nFlags
		   			
      DECLARE Integer InternetConnect IN WinInet ;
              Integer nInet_Handle, String @lpcServer, Short nPort, String @lpcUserName, ;
              String @lpcPassword, Integer nService, Integer nFlags, Integer nContext

      DECLARE Integer InternetCloseHandle IN WinInet ;
              Integer nConnect_Handle
		   			
      * FTP Functions
      DECLARE Integer FtpCreateDirectory IN WinInet ;
              Integer nConnect_Handle, String @lpcDirectory
		   			
      DECLARE Integer FtpDeleteFile IN WinInet ;
              Integer nConnect_Handle, String @lpcFileName
		   	
      DECLARE Integer FtpFindFirstFile IN WinInet ;
              Integer nConnect_Handle, String @lpcSearchStr, String @lpcWIN32_FIND_DATA, ;
              Integer nFlags, Integer nContext
		   			
      DECLARE Integer InternetFindNextFile IN WinInet ;
              Integer nConnect_Handle, String @lpcWIN32_FIND_DATA
		   			
      DECLARE Integer FtpGetCurrentDirectory IN WinInet ;
              Integer nConnect_Handle, String @lpcDirectory, Integer @nMax_Path
		   
      DECLARE Integer FtpGetFile IN WinInet ;
              Integer nConnect_Handle, String @lpcRemoteFile, String @lpcNewFile, ;
              Integer nFailIfExists, Integer nAttributes, Integer nFlags, ;
              Integer nContext
		   			
      DECLARE Integer FtpOpenFile IN WinInet ;
              Integer nConnect_Handle, String @lpcRemoteFile, Integer nAccessType, ;
              Integer nFlags, Integer nContext
		   			
      DECLARE Integer FtpPutFile IN WinInet ;
              Integer nConnect_Handle, String @lpcNewFile, String @lpcRemoteFile, ;
              Integer nFlags, Integer nContext
		   			
      DECLARE Integer FtpRemoveDirectory IN WinInet ;
              Integer nConnect_Handle, String @lpcDirectory
		   			
      DECLARE Integer FtpRenameFile IN WinInet ;
              Integer nConnect_Handle, String @lpcRemoteFile, String @lpcNewFile
		   			
      DECLARE Integer FtpSetCurrentDirectory IN WinInet ;
              Integer nConnect_Handle, String @lpcDirectory


      DECLARE Integer FtpCommand IN WinInet ;
              Integer hConnect, Integer fExpectResponse,;
              Integer dwFlags, STRING @ lpszCommand,;
              Integer dwContext, Integer @ phFtpCommand


      DECLARE INTEGER FtpGetFileSize IN WinInet ;
              INTEGER hFile,;
              INTEGER @ lpdwFileSizeHigh
		   			
      DECLARE Integer InternetGetLastResponseInfo IN WinInet ;
              Integer @nError, String @lpcBuffer, Integer @nMax_Path


      DECLARE INTEGER InternetWriteFile IN WinInet ;
              INTEGER hFile, STRING @ lpBuffer,;
              INTEGER dwNumberOfBytesToWrite, INTEGER @ lpdwNumberOfBytesWritten

      DECLARE INTEGER InternetReadFile IN WinInet ;
              INTEGER hFile, STRING @ lpBuffer,;
              INTEGER dwNumberOfBytesToWrite, INTEGER @ lpdwNumberOfBytesWritten


      DECLARE InternetQueryOption  IN WinInet ;
              INTEGER hInternet,;
              INTEGER dwOption,;
              INTEGER @ lpBuffer,;
              INTEGER @ lpdwBufferLength


      This.lDLL_Loaded = .T.
		   	
      RETURN ERROR_SUCCESS	
		   		
   ENDPROC


   PROCEDURE IsGlobalOffline()
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL liState
      liState = 0
      lnState = 4

      IF InternetQueryOption(0, INTERNET_OPTION_CONNECTED_STATE, @liState, @lnSize)
         RETURN IIF(BITTEST(liState,4)=1,0,1)
      ENDIF
      RETURN  -1
   ENDPROC
		
   ****************************************************
   PROCEDURE AutoDialInternet(lnType)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL lnHWNDHandle, fResult
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
 	      RETURN .F.
      ENDIF	
		   	  
      IF TYPE(lnType) != "N" 
         RETURN .F.
      ENDIF
		   	  
      =This.BeforeAutoDialInternet(lnType)
      lnHWNDHandle = 0	  		
      fResult = InternetAutodial(lnType, lnHWNDHandle)
      =This.GetExtendedError()
      =This.AfterAutoDialInternet(lnType,fResult)
      RETURN fResult # 0 
   ENDPROC

   ****************************************************
   PROCEDURE BeforeAutoDialInternet(lnType)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterAutoDialInternet(lnType,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC



   ****************************************************
   PROCEDURE AutoDialHangUp
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN .F.
      ENDIF	
	  		
      =This.BeforeAutoDialHangUp()
      fResult = InternetAutoDialHangUp(0)
      This.GetExtendedError()
      =This.AfterAutoDialHangUp(fResult)
	  		  
      RETURN fResult # 0 
   ENDPROC
	  		  
   ****************************************************
   PROCEDURE BeforeAutoDialHangUp()
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterAutoDialHangUp(fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC
	  
   ****************************************************	
   PROCEDURE DialInternet(lcDialUpName, lnFlag)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult, lnConnectionID, lnHWNDHandle
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN -1
      ENDIF
  	  		
      STORE 0 TO lnConnectionID,lnHWNDHandle
  	  		    	  		    	  		  
      IF TYPE("lcDialUpName") != "C" OR ;
         TYPE("lnFlag") != "N"
         RETURN -1
      ENDIF
  	  		
      IF LEN(ALLTRIM(lcDialUpName)) = 0 
         RETURN -1
      ENDIF
  	  		  
      lcDialUpName = lcDialUpName + cNULL
      =This.BeforeDialInternet(lcDialUpName, lnFlag)
      fResult = InternetDial(lnHWNDHandle, @lcDialUpName, lnFlag, @lnConnectionID, 0)
      =This.GetExtendedError()
      =This.AfterDialInternet(lcDialUpName, lnFlag,lnConnectionID,fResult)
      RETURN lnConnectionID
   ENDPROC  

   ****************************************************
   PROCEDURE BeforeDialInternet(lcDialUpName, lnFlag)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterDialInternet(lcDialUpName, lnFlag,lnConnectionID,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC


   ****************************************************
   PROCEDURE DialHangUp(lnConnectionID)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN .F.
      ENDIF
		   	  
      IF TYPE("lnConnectionID") != "N"
         RETURN .F.
      ENDIF
		   	  
      =This.BeforeDialHangUp(lnConnectionID)
      fResult = InternetHangUp(@lnConnectionID, 0)
      This.GetExtendedError()
      =This.AfterDialHangUp(lnConnectionID,fResult)
      RETURN fResult # 0 
   ENDPROC

   ****************************************************
   PROCEDURE BeforeDialHangUp(lnConnectionID)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterDialHangUp(lnConnectionID,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

	    
	    
   ****************************************************
   PROCEDURE GetConnectedState
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult, lnConnectionState
			
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN -1
      ENDIF
			
      lnConnectionState = 0
		
      =This.BeforeGetConnectedState()
      fResult = InternetGetConnectedState(@lnConnectionState, 0)
      =This.GetExtendedError()
      =This.AfterGetConnectedState(fResult,lnConnectionState)
      RETURN IIF(fResult = 0,-1,lnConnectionState)
   ENDPROC


   ****************************************************
   PROCEDURE BeforeGetConnectedState()
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterGetConnectedState(fResult,lnConnectionState)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC
		
			  
   ****************************************************	
   PROCEDURE GoOnline(lcURL)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL lnHWNDHandle, fResult
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN .F.
      ENDIF

      IF TYPE("lcURL") != "C"
         RETURN .F.
      ENDIF
	  			
      lcURL = lcURL + cNULL
      lnHWNDHandle = 0
      =This.BeforeGoOnline(lcURL)
      fResult = InternetGoOnline(@lcURL, lnHWNDHandle, 0)
      =This.GetExtendedError()
      =This.AfterGoOnline(lcURL,fResult)
      RETURN fResult # 0 
   ENDPROC	


   ****************************************************
   PROCEDURE BeforeGoOnline(lcURL)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterGoOnline(lcURL,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

		
   ****************************************************
   PROCEDURE OpenInternet(lcUserName, lcPassword, lcIPAddress, lcPort)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL lnPCount, fResult,lnConnectHandle,liAccessType,lcProxyBypass,lcProxyName
		   
      * Check Passed Parameters
      lnPCount = PCOUNT()
		   		   
      IF lnPCount <> 4
         This.nResult_Code = ERROR_INTERNET_BAD_OPTION_LENGTH
         RETURN .F.
      ENDIF
		   	
      * Make sure parameters are of the correct type
      IF (TYPE("lcUserName") != "C") OR ;
         (TYPE("lcPassword") != "C") OR ;
         (TYPE("lcIPAddress") != "C") OR ;
         (TYPE("lcPort") != "C")
         This.nResult_Code = ERROR_INVALID_PARAMETER
         RETURN .F.
      ENDIF
		   	
      * Check Parameter Values
      IF EMPTY(lcUserName) OR EMPTY(lcPassword) OR EMPTY(lcIPAddress)
         This.nResult_Code = ERROR_INTERNET_BAD_OPTION_LENGTH            
         RETURN .F.
      ENDIF
		   	
      IF This.LoadAPIFuncs() != ERROR_SUCCESS
         RETURN .F.
      ENDIF
		   	
		   	
      * Open Handle to Internet
      * Set Parameters
      This.cUserName = lcUserName + cNULL           && Store FTP Connection information
      This.cPassword = lcPassword + cNULL
      This.cIPAddress = lcIPAddress + cNULL
      This.cPort = lcPort


      IF EMPTY(This.cProxyHost) OR ISNULL(This.cProxyHost)
         lcProxyName = .NULL.
         liAccessType=INTERNET_OPEN_TYPE_DIRECT
         This.lUseProxy = .F.
         lcProxyBypass=.NULL.
      ELSE

         *protocol=proxyhost:proxyport
         *ftp=ftp://ftp_proxy_name:21 
         lcProxyName = This.cProxyProtocol+"="+ This.cProxyHost + ":" + ALLTRIM(This.cProxyport) + cNULL
         liAccessType=INTERNET_OPEN_TYPE_PROXY
         This.lUseProxy = .T.
         lcProxyBypass=This.cIPAddress
      ENDIF
		    		    	   		    		   
      This.nInet_Handle = InternetOpen((This.cAgent), INTERNET_OPEN_TYPE_DIRECT, @lcProxyName, @lcProxyBypass, 0)
      This.GetExtendedError()
		   	
		   	
      * Unable to Get a Connection into the Internet
      IF This.nInet_Handle = 0
         This.CloseFTPConnection()
         RETURN .F.
      ENDIF
		   
	
      * This Opens the FTP site and Gets the Current Directory.  The handle to the FTP site is opened
      * and closed for each call to any function.	
      * Open FTP Site 
      fResult=This.OpenFTPConnection(This.cStartupFolder)
      =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
      RETURN fResult
   ENDPROC

		
   ****************************************************
   PROCEDURE CloseInternet
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
 
      * Handles have a Hierarchy.  Closing the Top Handle will close all child handles also.
      * (really?)
      IF This.nInet_Handle != 0
         This.CloseFTPConnection()

         InternetCloseHandle(This.nInet_Handle)
         This.nInet_Handle = 0
      ENDIF
   ENDPROC
      


		
   ****************************************************
   PROTECTED PROCEDURE OpenFTPConnection(lcCurrentFolder)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL nHandle, lnConnect_Handle
      IF This.nConnect_Handle>0 AND .T. && is Valid??
         RETURN .T.
      ENDIF
      * Open FTP Site 
      lnConnect_Handle = InternetConnect(This.nInet_Handle, (This.cIPAddress), VAL(This.cPort), ;
                        (This.cUserName), (This.cPassword), INTERNET_SERVICE_FTP, This.nFlags, 0)
      This.GetExtendedError()
      IF lnConnect_Handle = 0
         RETURN .F.
      ENDIF

      IF PCOUNT()=0 OR EMPTY(lcCurrentFolder)
         lcCurrentFolder = SPACE(MAX_PATH)      
         fResult = FtpGetCurrentDirectory(lnConnect_Handle, @lcCurrentFolder, MAX_PATH)
         This.GetExtendedError()
                  
         IF fResult != 0
            This.cCurrentDir = lcCurrentFolder
         ENDIF
      ELSE
         lcCurrentFolder=This.cStartupFolder
         fResult = FtpSetCurrentDirectory(lnConnect_Handle, @lcCurrentFolder)
      ENDIF

      IF fResult = 1
         This.nConnect_Handle = lnConnect_Handle
         RETURN .T.
      ELSE
         This.GetExtendedError()     && Only Get extended Error information when there is an error
         RETURN .F.
      ENDIF
   ENDPROC
		
   ****************************************************
   PROTECTED PROCEDURE CloseFTPConnection
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      IF This.nConnect_Handle != 0
         =InternetCloseHandle(This.nConnect_Handle)
      ENDIF
	    	
      This.nConnect_Handle = 0
      RETURN
   ENDPROC
	    
		
   ****************************************************
   PROCEDURE SetCachingMethod(nCachingType)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult
		
      * only change caching type if we have a valid new cache type
      DO CASE 		  	
         CASE nCachingType = INTERNET_FLAG_DONT_CACHE
              This.nCachingType = INTERNET_FLAG_DONT_CACHE
              fResult = .T.

         CASE nCachingType = INTERNET_FLAG_HYPERLINK
              This.nCachingType = INTERNET_FLAG_HYPERLINK
              fResult = .T.

         CASE nCachingType = INTERNET_FLAG_MAKE_PERSISTENT
              This.nCachingType = INTERNET_FLAG_MAKE_PERSISTENT
              fResult = .T.

         CASE nCachingType = INTERNET_FLAG_MUST_CACHE_REQUEST
              This.nCachingType = INTERNET_FLAG_MUST_CACHE_REQUEST
              fResult = .T.

         CASE nCachingType = INTERNET_FLAG_RELOAD
              This.nCachingType = INTERNET_FLAG_RELOAD
              fResult = .T.

         CASE nCachingType = INTERNET_FLAG_NO_CACHE_WRITE
              This.nCachingType = INTERNET_FLAG_NO_CACHE_WRITE
              fResult = .T.

         CASE nCachingType = INTERNET_FLAG_RESYNCHRONIZE
              This.nCachingType = INTERNET_FLAG_RESYNCHRONIZE
              fResult = .T.

      ENDCASE
				
      RETURN fResult								
   ENDPROC
		
   ****************************************************
   PROCEDURE GetCachingMethod
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      RETURN This.nCachingType		  
   ENDPROC
		 
   ****************************************************
   PROCEDURE GetFTPFile(lcRemoteFile, lcLocalFile, llFailIfExists)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult, lnFail
      IF EMPTY(lcRemoteFile) OR EMPTY(lcLocalFile)
         RETURN .F.
      ENDIF
      IF This.OpenFTPConnection(This.cStartupFolder)     && Open an FTP Handle
         lnFail=IIF(llFailIfExists,1,0)
		  	  	
         lcLocalFile = lcLocalFile + cNULL
         lcRemoteFile = lcRemoteFile + cNULL
		  	  
         =This.BeforeGetFTPFile(lcRemoteFile, lcLocalFile, llFailIfExists)
         fResult = FtpGetFile(This.nConnect_Handle, @lcRemoteFile, @lcLocalFile, lnFail, ;
                              FILE_ATTRIBUTE_NORMAL, FTP_TRANSFER_TYPE_BINARY + This.nCachingType, 0)
         =This.GetExtendedError()
         =This.AfterGetFTPFile(lcRemoteFile, lcLocalFile, llFailIfExists,fResult)
		  	  	
         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
		  	  	
         RETURN fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC



   ****************************************************
   PROCEDURE BeforeGetFTPFile(lcRemoteFile, lcLocalFile, llFailIfExists)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterGetFTPFile(lcRemoteFile, lcLocalFile, llFailIfExists,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

	  	
   ****************************************************
   PROCEDURE PutFTPFile(lcRemoteFile, lclocalFile)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult
      IF EMPTY(lcRemoteFile) OR EMPTY(lcLocalFile)
         RETURN .F.
      ENDIF
      IF This.OpenFTPConnection(This.cStartupFolder)     && Open an FTP Handle
         lcRemoteFile = lcRemoteFile + cNULL
         lcLocalFile = lcLocalFile + cNULL
		  	  	  	  	
         =This.BeforePutFTPFile(lcRemoteFile, lclocalFile)
         fResult = FtpPutFile(This.nConnect_Handle, @lcLocalFile, @lcRemoteFile, ;
                              FTP_TRANSFER_TYPE_BINARY, 0)
         =This.GetExtendedError()
         =This.AfterPutFTPFile(lcRemoteFile, lclocalFile,fResult)

         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
	  	    	
         RETURN  fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC


   ****************************************************
   PROCEDURE BeforePutFTPFile(lcRemoteFile, lclocalFile)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterPutFTPFile(lcRemoteFile, lclocalFile,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC


   ****************************************************
   PROCEDURE WriteFTPFile(lcRemoteFile, lcData,liData,liStart,liFlags)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult,lihFTP,lcBuffer,liData,liWrite,lihFile,llFast,lcAll
      LOCAL ARRAY laFile(1)
      lihFile=0

      liData=IIF(PCOUNT()<3,512,liData)
      liData=IIF(liData<=0,512,liData)
      
      liStart=IIF(PCOUNT()<4,0,liStart)
      liFlags=IIF(PCOUNT()<5,_FTPS_RWF_File,liFlags)

      IF !BITTEST(liFlags,0) && File?
         IF ADIR(laFile,lcData,"RSHA")=0
            RETURN .F.
         ENDIF

         llFast=VAL(STRTRAN(SUBS(VERSION(),LEN("Visual FoxPro ")+1,2),"0",""))>5 AND laFile(1,2)<=_FTPS_MaxFileSize
         IF !llFast
            lihFile=FOPEN(lcData,0)
            IF lihFile<=0
               RETURN .F.
            ENDIF
            =FSEEK(lihFile,liStart,0)
         ELSE
            lcAll=FILETOSTR(lcData)
            lcAll=SUBST(lcAll,liStart+1)
         ENDIF
      ELSE
         lcData=IIF(TYPE("lcData")#"C","",lcData)
         lcData=SUBST(lcData,liStart+1)
         llFast=.T.
      ENDIF

      IF This.OpenFTPConnection(This.cStartupFolder)    && Open an FTP Handle
         lcRemoteFile = lcRemoteFile + cNULL

         =This.BeforeWriteFTPFile(lcRemoteFile, lcData,liData,liStart,liFlags)

         IF liStart<=0 && All data
            STORE FtpOpenFile(This.nConnect_Handle, @lcRemoteFile, GENERIC_WRITE, ;
                              FTP_TRANSFER_TYPE_BINARY, 0) TO fResult,lihFTP
            =This.GetExtendedError()
         ELSE
            * Append file
            fResult=IIF(This.FTPCommand("APPE "+lcRemoteFile, FTP_TRANSFER_TYPE_BINARY,0,@lihFTP),1,0)
         ENDIF

         IF fResult #0 && OK, FTP file is openned
            DO CASE
               CASE !BITTEST(liFlags,0) AND (laFile(1,2)=0 OR LEN(lcAll)=0) OR;
                     BITTEST(liFlags,0) AND LEN(lcData)=0
                    lcBuffer=""
                    liData=LEN(lcBuffer)

                    liWrite=0
                    fResult = InternetWriteFile(lihFTP, @lcBuffer, liData, @liWrite)
                    =This.GetExtendedError()
                    =This.AtWriteFTPFile(@lcRemoteFile, @lcData,liData,liStart,liFlags,liWrite,fResult)
                    IF fResult#1
                       EXIT
                    ENDIF
         
               CASE llFast AND !BITTEST(liFlags,0) && File
                    lii=1
               
                    DO WHILE lii<LEN(lcAll)
                       lcBuffer=SUBST(lcAll,lii,liData)
                       liData=LEN(lcBuffer)

                       liWrite=0
                       fResult = InternetWriteFile(lihFTP, @lcBuffer, liData, @liWrite)
                       =This.GetExtendedError()
                       =This.AtWriteFTPFile(@lcRemoteFile, @lcData,liData,liStart,liFlags,liWrite,fResult)
                       IF fResult#1
                          EXIT
                       ENDIF
                       lii=lii+liData
                    ENDDO

               CASE BITTEST(liFlags,0) && String
                    lii=1
               
                    DO WHILE lii<LEN(lcData)
                       lcBuffer=SUBST(lcData,lii,liData)
                       liData=LEN(lcBuffer)

                       liWrite=0
                       fResult = InternetWriteFile(lihFTP, @lcBuffer, liData, @liWrite)
                       =This.GetExtendedError()
                       =This.AtWriteFTPFile(@lcRemoteFile, @lcData,liData,liStart,liFlags,liWrite,fResult)
                       IF fResult#1
                          EXIT
                       ENDIF
                       lii=lii+liData
                    ENDDO

               OTHERWISE
                    DO WHILE !FEOF(lihFile)
                       lcBuffer=FREAD(lihFile,liData)
                       liData=LEN(lcBuffer)

                       liWrite=0
                       fResult = InternetWriteFile(lihFTP, @lcBuffer, liData, @liWrite)
                       =This.GetExtendedError()
                       =This.AtWriteFTPFile(@lcRemoteFile, @lcData,liData,liStart,liFlags,liWrite,fResult)
                       IF fResult#1
                          EXIT
                       ENDIF
                    ENDDO
                    =FCLOSE(lihFile)
            ENDCASE

            =IIF(liStart>0,This.FTPCommand("NOOP", FTP_TRANSFER_TYPE_BINARY,0,.NULL.),.T.)
            =InternetCloseHandle(lihFTP)
         ENDIF

         =This.AfterWriteFTPFile(lcRemoteFile, lcData,liData,liStart,liFlags,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
         RETURN fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC



   ****************************************************
   PROCEDURE BeforeWriteFTPFile(lcRemoteFile, lcData,liData,liStart,liFlags)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterWriteFTPFile(lcRemoteFile, lcData,liData,liStart,liFlags,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AtWriteFTPFile(lcRemoteFile, lcData,liData,liStart,liFlags,liWrite,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC



   ****************************************************
   PROCEDURE ReadFTPFile(lcRemoteFile, lcData,liData,liRStart,liLStart,liFlags)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult,lihFTP,lcBuffer,liData,liRead,lihFile,llFast,lcAll,llAppend,liFSize
      lihFile=0
      liData=IIF(PCOUNT()<3,512,liData)
      liData=IIF(liData<=0,512,liData)
      
      liRStart=IIF(PCOUNT()<4,0,liRStart)
      liLStart=IIF(PCOUNT()<5,0,liLStart)
      liFlags=IIF(PCOUNT()<6,_FTPS_RWF_Resume+_FTPS_RWF_File,liFlags)

      IF !BITTEST(liFlags,0) && File?
         llFast=VAL(STRTRAN(SUBS(VERSION(),LEN("Visual FoxPro ")+1,2),"0",""))>6
         IF !llFast
            lihFile=FOPEN(lcData,0)
            lihFile=IIF(lihFile<=0,FCREATE(lcData,0),lihFile)

            IF lihFile<=0
               RETURN .F.
            ENDIF
            =IIF(BITTEST(liFlags,1),; && rewrite, skip to new position
                 FSEEK(lihFile,liLStart,0),;
                 FSEEK(lihFile,liRStart,0)) && resume native mode
         ELSE
            lcAll=FILETOSTR(lcData)
            lcAll=IIF(BITTEST(liFlags,1),; && rewrite, skip to new position
                      LEFT(lcAll,liLStart),LEFT(lcAll,liRStart))
         ENDIF
      ELSE
         lcData=IIF(TYPE("lcData")#"C","",lcdata)
         lcData=IIF(BITTEST(liFlags,1),; && rewrite, skip to new position
                    LEFT(lcData,liLStart),LEFT(lcData,liRStart))
         llFast=.T.
      ENDIF

      IF This.OpenFTPConnection(This.cStartupFolder) && Open an FTP Handle
         lcRemoteFile = lcRemoteFile + cNULL

         =This.BeforeReadFTPFile(@lcRemoteFile, @lcData,liData,liRStart,liLStart,liFlags)
         IF liRStart<=0 && All data
            STORE FtpOpenFile(This.nConnect_Handle, @lcRemoteFile, GENERIC_READ, ;
                              FTP_TRANSFER_TYPE_BINARY, 0) TO fResult,lihFTP
            =This.GetExtendedError()
         ELSE
            fResult=0
            =This.FTPCommand("REST "+LTRIM(STR(liRStart,11)), FTP_TRANSFER_TYPE_BINARY,0,.NULL.)
            IF This.FTPCommand("RETR "+lcRemoteFile, FTP_TRANSFER_TYPE_BINARY,0,@lihFTP)
               fResult=1
            ENDIF
         ENDIF

         IF fResult #0 && OK, FTP file is openned
            lii=0
            STORE 1 TO fResult,liRead

            DO WHILE liRead>0
               liRead=0
               lcBuffer=SPACE(liData)
               fResult = InternetReadFile(lihFTP, @lcBuffer, liData, @liRead)
               =This.GetExtendedError()
               =This.AtReadFTPFile(@lcRemoteFile, @lcData,liData,liRStart,liLStart,liFlags,@lcBuffer,fResult)

               IF !BITTEST(liFlags,0) && File?
                  IF llFast AND liRead>0
                     IF LEN(lcAll)+liRead>_FTPS_MaxFileSize
                        =STRTOFILE(lcAll,lcData,llAppend)
                        llAppend=.T.
                        lcAll=""
                     ENDIF
                     lcAll=lcAll+LEFT(lcBuffer,liRead)
                  ELSE
                     IF liRead>0
                        =FWRITE(lihFile,LEFT(lcBuffer,liRead),liRead)
                     ENDIF
                  ENDIF
               ELSE
                  lcData=lcData+LEFT(lcBuffer,liRead)
               ENDIF
               lii=lii+liRead
            ENDDO

            IF !BITTEST(liFlags,0)
                =IIF(llFast AND LEN(lcAll)>0,; && File?
                     STRTOFILE(lcAll,lcData,llAppend),.T.)
                =IIF(lihFile>0 AND !llFast,FCLOSE(lihFile),.T.)
            ENDIF
            =InternetCloseHandle(lihFTP)

            =IIF(liRStart>0,This.FTPCommand("NOOP", FTP_TRANSFER_TYPE_BINARY,0,.NULL.),.T.)
         ENDIF

         =This.AfterReadFTPFile(@lcRemoteFile, @lcData,liData,liRStart,liLStart,liFlags,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
         RETURN  fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC



   ****************************************************
   PROCEDURE BeforeReadFTPFile(lcRemoteFile, lcData,liData,liRStart,liLStart,liFlags)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterReadFTPFile(lcRemoteFile, lcData,liData,liRStart,liLStart,liFlags,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AtReadFTPFile(lcRemoteFile, lcData,liData,liRStart,liLStart,liFlags,lcBuffer,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE FTPCommand(lcCommand, liFlags, liContext,lihFTP)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult
      IF This.OpenFTPConnection(This.cStartupFolder)     && Open an FTP Handle
         liFlags=IIF(PCOUNT()<2,FTP_TRANSFER_TYPE_BINARY,liFlags)
         liContext=IIF(PCOUNT()<3,0,liContext)
         lihFTP=IIF(ISNULL(lihFTP),-1,0)

         lcCommand = lcCommand + cNULL
         =This.BeforeFTPCommand(lcCommand, liFlags, liContext)
         fResult = FtpCommand(This.nConnect_Handle, IIF(lihFTP=-1,0,1), liFlags, @lcCommand,liContext,@lihFTP)

         =This.GetExtendedError()
         =This.AfterFTPCommand(lcCommand, liFlags, liContext,lihFTP,fResult)

         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
         RETURN  fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC


   ****************************************************
   PROCEDURE BeforeFTPCommand(lcCommand, liFlags, liContext)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterFTPCommand(lcCommand, liFlags, liContext,lihFTP,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC




	  	
   ****************************************************
   PROCEDURE DeleteFTPFile(lcRemoteFile)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult
      IF This.OpenFTPConnection(This.cStartupFolder)     && Open an FTP Handle
         lcRemoteFile = lcRemoteFile + cNULL
		  	  		  	  	  	  	
         =This.BeforeDeleteFTPFile(lcRemoteFile)
         fResult = FtpDeleteFile(This.nConnect_Handle, @lcRemoteFile)
         This.GetExtendedError()
         =This.AfterDeleteFTPFile(lcRemoteFile,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
         RETURN fResult = 1
      ENDIF
      RETURN .F.    	  	  	
   ENDPROC

   ****************************************************
   PROCEDURE BeforeDeleteFTPFile(lcRemoteFile)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterDeleteFTPFile(lcRemoteFile,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC
		
		
   ****************************************************
   PROCEDURE RenameFTPFile(lcOldFile, lcNewFile)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult
      IF This.OpenFTPConnection(This.cStartupFolder)     && Open an FTP Handle
         lcOldFile = lcOldFile + cNULL
         lcNewFile = lcNewFile + cNULL
		  	  	  	  	
         =This.BeforeRenameFTPFile(lcOldFile, lcNewFile)
         fResult = FtpRenameFile(This.nConnect_Handle, @lcOldFile, @lcNewFile)
         =This.GetExtendedError()
         =This.AfterRenameFTPFile(lcOldFile, lcNewFile,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
         RETURN fResult = 1
      ENDIF
      RETURN .F.    	  	  	
   ENDPROC
		

   ****************************************************
   PROCEDURE BeforeRenameFTPFile(lcOldFile, lcNewFile)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterRenameFTPFile(lcOldFile, lcNewFile,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC
		
		
   ****************************************************
   PROCEDURE CreateFTPDirectory(lcNewDir)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult
      IF This.OpenFTPConnection(This.cStartupFolder)     && Open an FTP Handle  	   		
         lcNewDir = lcNewDir + cNULL
		  	   	  	   		  	   	 
         =This.BeforeCreateFTPDirectory(lcNewDir)
         fResult = FtpCreateDirectory(This.nConnect_Handle, @lcNewDir)
         =This.GetExtendedError()
         =This.AfterCreateFTPDirectory(lcNewDir,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
		  	 	
         RETURN fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC


   ****************************************************
   PROCEDURE BeforeCreateFTPDirectory(lcNewDir)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterCreateFTPDirectory(lcNewDir,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>

   ENDPROC

	  	
   ****************************************************
   PROCEDURE RemoveFTPDirectory(lcDir)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult
      IF This.OpenFTPConnection(This.cStartupFolder)     && Open an FTP Handle  	   		  
         lcDir = lcDir + cNULL
		  	   	  	   		  	   	 
         =This.BeforeRemoveFTPDirectory(lcDir)
         fResult = FtpRemoveDirectory(This.nConnect_Handle, @lcDir)
         =This.GetExtendedError()
         =This.AfterRemoveFTPDirectory(lcDir,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
		  	 	
         RETURN fResult = 1
      ENDIF
      RETURN .F. 
   ENDPROC


   ****************************************************
   PROCEDURE BeforeRemoveFTPDirectory(lcDir)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterRemoveFTPDirectory(lcDir,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC
			 
   ****************************************************
   PROCEDURE ChangeFTPDirectory(lcNewDir)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult, lcTempDir, llResult
	  	   	  	   		  
      IF This.OpenFTPConnection(This.cStartupFolder)     && Open an FTP Handle 	   		  
         llResult = .F.	 
	  	   	  	   		  	   
         lcNewDir = lcNewDir + cNULL  
         lcTempDir = SPACE(MAX_PATH)	   		  	   	
		  	   	  	   		  	   	 
         =This.BeforeChangeFTPDirectory(lcNewDir)
         fResult = FtpSetCurrentDirectory(This.nConnect_Handle, @lcNewDir)
         =This.GetExtendedError()
		  	 		  	 	
         IF fResult = 1
            fResult = FtpGetCurrentDirectory(This.nConnect_Handle, @lcTempDir, MAX_PATH)
            =This.GetExtendedError()
		  	 		  	 		
            IF fResult = 1
               This.cCurrentDir = lcTempDir
               llResult = .T.
            ENDIF
         ENDIF
         =This.AfterChangeFTPDirectory(lcNewDir,fResult)
		  	 	
         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
         RETURN llResult
      ENDIF	  	 
      RETURN .F. 		  	 
   ENDPROC

   ****************************************************
   PROCEDURE BeforeChangeFTPDirectory(lcNewDir)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterChangeFTPDirectory(lcNewDir,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC
	  	
   ****************************************************
   PROCEDURE GetFTPDirectory(lcDirectory)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL fResult, lcTempDir
      IF This.OpenFTPConnection(This.cStartupFolder)     && Open an FTP Handle
         lcTempDir = SPACE(MAX_PATH)
         =This.BeforeGetFTPDirectory(lcDirectory)
         fResult = FtpGetCurrentDirectory(This.nConnect_Handle, @lcTempDir, MAX_PATH)
         =This.GetExtendedError()
         lcDirectory = LEFT(lcTempDir, AT(cNULL, lcTempDir) - 1)
         =This.AfterGetFTPDirectory(lcDirectory,fResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
         RETURN fResult = 1
      ENDIF
      RETURN .F.
   ENDPROC

   ****************************************************
   PROCEDURE BeforeGetFTPDirectory(lcDirectory)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterGetFTPDirectory(lcDirectory,fResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC
		
				
   ****************************************************
   PROCEDURE GetFTPDirectoryArray(laDirectory, lcMask)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL cStruct, llResult, lnCount, fResult, lffHandle
      IF This.OpenFTPConnection(This.cStartupFolder)     && Open an FTP Handle
         lcMask = lcMask + cNULL
		      
         * Dimension the array to store the directory
         * [x, 1] = FileName
         * [x, 2] = Alternate FileName
         * [x, 3] = File Size
         * [x, 4] = File Create Date
         * [x, 5] = File Last Access Time
         * [x, 6] = File Last Write Time
         * [x, 7] = File Attributes
         DIMENSION laDirectory [1, 7]
         laDirectory [1, 1] = .F.
		    	      	
         * This is for a FoxPro Quirk.
         lcStruct = SPACE(319)   && Allocate space for the returned structure
		      	
         =This.BeforeGetFTPDirectoryArray(@laDirectory, lcMask)
         * Get the first file or find out if 
         lffHandle = FtpFindFirstFile(This.nConnect_Handle, @lcMask, @lcStruct, 0, 0)
         This.GetExtendedError()
		      	
         IF lffHandle = 0 OR This.nResult_Code = ERROR_NO_MORE_FILES
            =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
            RETURN .F.
         ENDIF
		      
         * Parse out First File Information
         =This.CrackFile(lcStruct, @laDirectory)
		      	
         llResult = 1
         DO WHILE This.nResult_Code != ERROR_NO_MORE_FILES AND llResult != 0
            lcStruct = SPACE(319)
            * Get next files
            llResult = InternetFindNextFile(lffHandle, @lcStruct)
            =This.GetExtendedError()
			    		
            * If we got good information, go ahead and parse it
            IF This.nResult_Code != ERROR_NO_MORE_FILES AND llResult != 0
               =This.CrackFile(lcStruct, @laDirectory)
            ENDIF
         ENDDO
         =This.AfterGetFTPDirectoryArray(laDirectory, lcMask,llResult)
         =IIF(This.lMultiOperations,.T.,This.CloseFTPConnection())   && Close FTP Handle
      ELSE
         RETURN .F.     && Unable to get FTP Connection	
      ENDIF
      RETURN .T.
   ENDPROC


   ****************************************************
   PROCEDURE BeforeGetFTPDirectoryArray(laDirectory, lcMask)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

   ****************************************************
   PROCEDURE AfterGetFTPDirectoryArray(laDirectory, lcMask,llResult)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
   ENDPROC

		
   ****************************************************
   PROCEDURE GetErrorCode(llShowMessage)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL lcMessage
      IF llShowMessage = .T.
         * Build Error Message Here
         lcMessage = "Error (" + ALLTRIM(STR(This.nResult_Code)) + ")  -  " + ;
                     This.GetErrorText(This.nResult_Code)
         IF !EMPTY(This.cExtended_Message)
            lcMessage = lcMessage + CHR(13) + CHR(13) + "Extended Error Info - (" + ;
                        ALLTRIM(STR(This.nExtended_Result)) + ;
                        ") - " + This.cExtended_Message
         ENDIF
         =MESSAGEBOX(lcMessage, 48, "FTP Error Message")
      ENDIF
      RETURN This.nResult_Code
   ENDPROC
	 	
	 	
   ****************************************************
   PROCEDURE GetExtendedErrorCode
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      RETURN This.nExtended_Result
   ENDPROC
	 	
	 	
   ****************************************************
   PROCEDURE GetExtendedErrorMsg
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      RETURN This.cExtended_Message
   ENDPROC
	 	
	 	
   ****************************************************
   PROTECTED PROCEDURE CrackFile(lcString, laDirectory)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL lcFileName, lcAlterName, lnSizeHigh, lnSizeLow, lnFileSize, ;
            lcAttributes, lnArrayLen, lcTimeBuff, ;
            ldCreateDate, ldAccessDate, ldWriteDate, laNewArray, lnResult
	      	
      IF TYPE('laDirectory[1, 1]') = 'L'	&& Array Has Not Been Filed      
         * Force Record size of 1
         DIMENSION laDirectory [1, 7]
      ELSE	
         * Expand Array
         DIMENSION laDirectory [ALEN(laDirectory, 1) + 1, 7]
      ENDIF
	        
      * Get new Array Position
      lnArrayLen = ALEN(laDirectory, 1)
          		       	      
      lcFileName = SUBSTR(lcString, 45, MAX_PATH)
      lcAlterName = RIGHT(lcString, 14)
	      	
      lcFileName = LEFT(lcFileName, AT(cNull, lcFileName) - 1)  && Copy out just the File Name Text
      lcAlterName = LEFT(lcAlterName, AT(cNull, lcAlterName) - 1)
	      	
      * Convert File Size DWORDs
      lnSizeHigh = (ASC(SUBSTR(lcString, 29, 1)) * BYTE_1) + ;
                   (ASC(SUBSTR(lcString, 30, 1)) * BYTE_2) + ;
                   (ASC(SUBSTR(lcString, 31, 1)) * BYTE_3) + ;
                   (ASC(SUBSTR(lcString, 32, 1)) * BYTE_4) 
	      				 
      lnSizeLow =  (ASC(SUBSTR(lcString, 33, 1)) * BYTE_1) + ;
                   (ASC(SUBSTR(lcString, 34, 1)) * BYTE_2) + ;
                   (ASC(SUBSTR(lcString, 35, 1)) * BYTE_3) + ;
                   (ASC(SUBSTR(lcString, 36, 1)) * BYTE_4) 
	      				 
      * Build File Size
      lnFileSize = (lnSizeHigh * MAXDWORD) + lnSizeLow
	      	
      * Convert File Date
	       
      * Get File Create DateTime
      lcTimeBuff = SUBSTR(lcString, 5, 8)
      ldCreateDate = This.CrackDate(lcTimeBuff)
	        
      * Get File Create DateTime
      lcTimeBuff = SUBSTR(lcString, 13, 8)
      ldAccessDate = This.CrackDate(lcTimeBuff)
	        
      * Get File Create DateTime
      lcTimeBuff = SUBSTR(lcString, 21, 8)
      ldWriteDate = This.CrackDate(lcTimeBuff)
	        
      * Get File Attributes
      lcAttributes = This.CrackAttributes(LEFT(lcString, 4))
	        
      laDirectory[lnArrayLen, 1] = ALLTRIM(lcFileName)
      laDirectory[lnArrayLen, 2] = ALLTRIM(lcAlterName)
      laDirectory[lnArrayLen, 3] = lnFileSize
      laDirectory[lnArrayLen, 4] = ldCreateDate
      laDirectory[lnArrayLen, 5] = ldAccessDate
      laDirectory[lnArrayLen, 6] = ldWriteDate
      laDirectory[lnArrayLen, 7] = lcAttributes
  	 
      RETURN 
   ENDPROC
	    
   ****************************************************
   PROTECTED PROCEDURE CrackDate(lcOutBuffer)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL lcInBuffer, ldDateTime, fResult, lcBuild, ;
            lnDay, lnMonth, lnYear, lnHour, lnMinute, lnSecond
		
      lcInBuffer = SPACE(16)
		
      fResult = FileTimeToSystemTime(@lcOutBuffer, @lcInBuffer)
      This.GetExtendedError()
			
      IF fResult = 0   && Failed
         ldDateTime = {^1901/01/01 00:00:01}   && Default Time
         RETURN ldDateTime
      ENDIF
			
      lnYear = ASC(SUBSTR(lcInBuffer, 1, 1)) + (ASC(SUBSTR(lcInBuffer, 2, 1)) * BYTE_2)
      lnMonth = ASC(SUBSTR(lcInBuffer, 3, 1)) + (ASC(SUBSTR(lcInBuffer, 4, 1)) * BYTE_2)
      lnDay = ASC(SUBSTR(lcInBuffer, 7, 1)) + (ASC(SUBSTR(lcInBuffer, 8, 1)) * BYTE_2)
      lnHour = ASC(SUBSTR(lcInBuffer, 9, 1)) + (ASC(SUBSTR(lcInBuffer, 10, 1)) * BYTE_2)
      lnMinute = ASC(SUBSTR(lcInBuffer, 11, 1)) + (ASC(SUBSTR(lcInBuffer, 12, 1)) * BYTE_2)
      lnSecond = ASC(SUBSTR(lcInBuffer, 13, 1)) + (ASC(SUBSTR(lcInBuffer, 13, 1)) * BYTE_2)
			
      lcBuild = "^" + ALLTRIM(STR(lnYear)) + '/' + ALLTRIM(STR(lnMonth)) + '/' + ALLTRIM(STR(lnDay)) + ' ' + ;
                ALLTRIM(STR(lnHour)) + ':' + ALLTRIM(STR(lnMinute)) + ':' + ALLTRIM(STR(lnSecond))
				      
      ldDateTime = {&lcBuild}
      RETURN ldDateTime
   ENDPROC
		  
   ****************************************************
   PROTECTED PROCEDURE CrackAttributes(lcBuffer)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL lcAttributes, lnValue
      lcAttributes = ''
	 		 		
      lnValue = (ASC(SUBSTR(lcBuffer, 1, 1)) * BYTE_1) + ;
                (ASC(SUBSTR(lcBuffer, 2, 1)) * BYTE_2) + ;
                (ASC(SUBSTR(lcBuffer, 3, 1)) * BYTE_3) + ;
                (ASC(SUBSTR(lcBuffer, 4, 1)) * BYTE_4) 
					  
      DO CASE
         CASE BITTEST(lnValue, BIT_ATTRIBUTE_READONLY) 
              lcAttributes = lcAttributes + 'R'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_HIDDEN) 
              lcAttributes = lcAttributes + 'H'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_SYSTEM) 
              lcAttributes = lcAttributes + 'S'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_DIRECTORY) 
              lcAttributes = lcAttributes + 'D'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_ARCHIVE) 
              lcAttributes = lcAttributes + 'A'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_NORMAL) 
              lcAttributes = lcAttributes + 'N'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_TEMPORARY) 
              lcAttributes = lcAttributes + 'T'

         CASE BITTEST(lnValue, BIT_ATTRIBUTE_COMPRESSED) 
              lcAttributes = lcAttributes + 'C'
   
         CASE BITTEST(lnValue, BIT_ATTRIBUTE_OFFLINE) 
              lcAttributes = lcAttributes + 'O'
      ENDCASE
						
      RETURN lcAttributes
   ENDPROC
		

   ****************************************************
   PROTECTED PROCEDURE GetExtendedError
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL lcMessage, lnError, lcBuffer
      This.nResult_Code = GetLastError()
	        
      lnError = 0
      lcBuffer = SPACE(MAX_PATH)
	        
      =InternetGetLastResponseInfo(lnError, @lcBuffer, MAX_PATH)
		    
      This.nExtended_Result = lnError
      This.cExtended_Message = LEFT(lcBuffer, AT(cNULL, lcBuffer) - 1)
      RETURN 
   ENDPROC
				
   ****************************************************
   PROCEDURE GetErrorText(lnError)
      *!*	<pdm_sc_yes/>
      *!*	<pdm_dd_yes/>
      LOCAL lcMessage
      DO CASE
         CASE lnError =  ERROR_INTERNET_OUT_OF_HANDLES                
              lcMessage = "ERROR_INTERNET_OUT_OF_HANDLES"

         CASE lnError =  ERROR_INTERNET_TIMEOUT                       
              lcMessage = "ERROR_INTERNET_TIMEOUT"

         CASE lnError =  ERROR_INTERNET_EXTENDED_ERROR                
              lcMessage = "ERROR_INTERNET_EXTENDED_ERROR"

         CASE lnError =  ERROR_INTERNET_INTERNAL_ERROR                
              lcMessage = "ERROR_INTERNET_INTERNAL_ERROR"

         CASE lnError =  ERROR_INTERNET_INVALID_URL                   
              lcMessage = "ERROR_INTERNET_INVALID_URL"

         CASE lnError =  ERROR_INTERNET_UNRECOGNIZED_SCHEME           
              lcMessage = "ERROR_INTERNET_UNRECOGNIZED_SCHEME"

         CASE lnError =  ERROR_INTERNET_NAME_NOT_RESOLVED             
              lcMessage = "ERROR_INTERNET_NAME_NOT_RESOLVED"

         CASE lnError =  ERROR_INTERNET_PROTOCOL_NOT_FOUND            
              lcMessage = "ERROR_INTERNET_PROTOCOL_NOT_FOUND"

         CASE lnError =  ERROR_INTERNET_INVALID_OPTION                
              lcMessage = "ERROR_INTERNET_INVALID_OPTION"

         CASE lnError =  ERROR_INTERNET_BAD_OPTION_LENGTH             
              lcMessage = "ERROR_INTERNET_BAD_OPTION_LENGTH"

         CASE lnError =  ERROR_INTERNET_OPTION_NOT_SETTABLE           
              lcMessage = "ERROR_INTERNET_OPTION_NOT_SETTABLE"

         CASE lnError =  ERROR_INTERNET_SHUTDOWN                      
              lcMessage = "ERROR_INTERNET_SHUTDOWN"

         CASE lnError =  ERROR_INTERNET_INCORRECT_USER_NAME           
              lcMessage = "ERROR_INTERNET_INCORRECT_USER_NAME"

         CASE lnError =  ERROR_INTERNET_INCORRECT_PASSWORD            
              lcMessage = "ERROR_INTERNET_INCORRECT_PASSWORD"

         CASE lnError =  ERROR_INTERNET_LOGIN_FAILURE                 
              lcMessage = "ERROR_INTERNET_LOGIN_FAILURE"

         CASE lnError =  ERROR_INTERNET_INVALID_OPERATION             
              lcMessage = "ERROR_INTERNET_INVALID_OPERATION"

         CASE lnError =  ERROR_INTERNET_OPERATION_CANCELLED           
              lcMessage = "ERROR_INTERNET_OPERATION_CANCELLED"

         CASE lnError =  ERROR_INTERNET_INCORRECT_HANDLE_TYPE         
              lcMessage = "ERROR_INTERNET_INCORRECT_HANDLE_TYPE"

         CASE lnError =  ERROR_INTERNET_INCORRECT_HANDLE_STATE        
              lcMessage = "ERROR_INTERNET_INCORRECT_HANDLE_STATE"

         CASE lnError =  ERROR_INTERNET_NOT_PROXY_REQUEST             
              lcMessage = "ERROR_INTERNET_NOT_PROXY_REQUEST"

         CASE lnError =  ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND      
              lcMessage = "ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND"

         CASE lnError =  ERROR_INTERNET_BAD_REGISTRY_PARAMETER        
              lcMessage = "ERROR_INTERNET_BAD_REGISTRY_PARAMETER"

         CASE lnError =  ERROR_INTERNET_NO_DIRECT_ACCESS              
              lcMessage = "ERROR_INTERNET_NO_DIRECT_ACCESS"

         CASE lnError =  ERROR_INTERNET_NO_CONTEXT                    
              lcMessage = "ERROR_INTERNET_NO_CONTEXT"

         CASE lnError =  ERROR_INTERNET_NO_CALLBACK                   
              lcMessage = "ERROR_INTERNET_NO_CALLBACK"

         CASE lnError =  ERROR_INTERNET_REQUEST_PENDING               
              lcMessage = "ERROR_INTERNET_REQUEST_PENDING"

         CASE lnError =  ERROR_INTERNET_INCORRECT_FORMAT              
              lcMessage = "ERROR_INTERNET_INCORRECT_FORMAT"

         CASE lnError =  ERROR_INTERNET_ITEM_NOT_FOUND                
              lcMessage = "ERROR_INTERNET_ITEM_NOT_FOUND"

         CASE lnError =  ERROR_INTERNET_CANNOT_CONNECT                
              lcMessage = "ERROR_INTERNET_CANNOT_CONNECT"

         CASE lnError =  ERROR_INTERNET_CONNECTION_ABORTED            
              lcMessage = "ERROR_INTERNET_CONNECTION_ABORTED"

         CASE lnError =  ERROR_INTERNET_CONNECTION_RESET              
              lcMessage = "ERROR_INTERNET_CONNECTION_RESET"

         CASE lnError =  ERROR_INTERNET_FORCE_RETRY                   
              lcMessage = "ERROR_INTERNET_FORCE_RETRY"

         CASE lnError =  ERROR_INTERNET_INVALID_PROXY_REQUEST         
              lcMessage = "ERROR_INTERNET_INVALID_PROXY_REQUEST"

         CASE lnError =  ERROR_INTERNET_NEED_UI                       
              lcMessage = "ERROR_INTERNET_NEED_UI"

         CASE lnError =  ERROR_INTERNET_HANDLE_EXISTS                 
              lcMessage = "ERROR_INTERNET_HANDLE_EXISTS"

         CASE lnError =  ERROR_INTERNET_SEC_CERT_DATE_INVALID         
              lcMessage = "ERROR_INTERNET_SEC_CERT_DATE_INVALID"

         CASE lnError =  ERROR_INTERNET_SEC_CERT_CN_INVALID           
              lcMessage = "ERROR_INTERNET_SEC_CERT_CN_INVALID"

         CASE lnError =  ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR        
              lcMessage = "ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR"

         CASE lnError =  ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR        
              lcMessage = "ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR"

         CASE lnError =  ERROR_INTERNET_MIXED_SECURITY                
              lcMessage = "ERROR_INTERNET_MIXED_SECURITY"

         CASE lnError =  ERROR_INTERNET_CHG_POST_IS_NON_SECURE        
              lcMessage = "ERROR_INTERNET_CHG_POST_IS_NON_SECURE"

         CASE lnError =  ERROR_INTERNET_POST_IS_NON_SECURE            
              lcMessage = "ERROR_INTERNET_POST_IS_NON_SECURE"

         CASE lnError =  ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED       
              lcMessage = "ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED"

         CASE lnError =  ERROR_INTERNET_INVALID_CA                    
              lcMessage = "ERROR_INTERNET_INVALID_CA"

         CASE lnError =  ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP         
              lcMessage = "ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP"

         CASE lnError =  ERROR_INTERNET_ASYNC_THREAD_FAILED           
              lcMessage = "ERROR_INTERNET_ASYNC_THREAD_FAILED"

         CASE lnError =  ERROR_INTERNET_REDIRECT_SCHEME_CHANGE        
              lcMessage = "ERROR_INTERNET_REDIRECT_SCHEME_CHANGE"

         CASE lnError =  ERROR_INTERNET_DIALOG_PENDING                
              lcMessage = "ERROR_INTERNET_DIALOG_PENDING"

         CASE lnError =  ERROR_INTERNET_RETRY_DIALOG                  
              lcMessage = "ERROR_INTERNET_RETRY_DIALOG"

         CASE lnError =  ERROR_INTERNET_HTTPS_HTTP_SUBMIT_REDIR       
              lcMessage = "ERROR_INTERNET_HTTPS_HTTP_SUBMIT_REDIR"

         CASE lnError =  ERROR_INTERNET_INSERT_CDROM                  
              lcMessage = "ERROR_INTERNET_INSERT_CDROM"

         CASE lnError =  FTP_TRANSFER_IN_PROGRESS            	     
              lcMessage = "FTP_TRANSFER_IN_PROGRESS"

         CASE lnError =  FTP_DROPPED                         	     
              lcMessage = "FTP_DROPPED"

         CASE lnError =  FTP_NO_PASSIVE_MODE                          
              lcMessage = "FTP_NO_PASSIVE_MODE"

         CASE lnError =  ERROR_INTERNET_SECURITY_CHANNEL_ERROR        
              lcMessage = "ERROR_INTERNET_SECURITY_CHANNEL_ERROR"

         CASE lnError =  ERROR_INTERNET_UNABLE_TO_CACHE_FILE          
              lcMessage = "ERROR_INTERNET_UNABLE_TO_CACHE_FILE"

         CASE lnError =  ERROR_INTERNET_TCPIP_NOT_INSTALLED           
              lcMessage = "ERROR_INTERNET_TCPIP_NOT_INSTALLED"

         CASE lnError =  ERROR_INTERNET_DISCONNECTED                  
              lcMessage = "ERROR_INTERNET_DISCONNECTED"

         CASE lnError =  ERROR_INTERNET_SERVER_UNREACHABLE            
              lcMessage = "ERROR_INTERNET_SERVER_UNREACHABLE"

         CASE lnError =  ERROR_INTERNET_PROXY_SERVER_UNREACHABLE      
              lcMessage = "ERROR_INTERNET_PROXY_SERVER_UNREACHABLE"

         CASE lnError =  ERROR_INTERNET_BAD_AUTO_PROXY_SCRIPT         
              lcMessage = "ERROR_INTERNET_BAD_AUTO_PROXY_SCRIPT"

         CASE lnError =  ERROR_INTERNET_UNABLE_TO_DOWNLOAD_SCRIPT     
              lcMessage = "ERROR_INTERNET_UNABLE_TO_DOWNLOAD_SCRIPT"

         CASE lnError =  ERROR_INTERNET_SEC_INVALID_CERT    		     
              lcMessage = "ERROR_INTERNET_SEC_INVALID_CERT"

         CASE lnError =  ERROR_INTERNET_SEC_CERT_REVOKED    		     
              lcMessage = "ERROR_INTERNET_SEC_CERT_REVOKED"

         CASE lnError =  ERROR_NO_MORE_FILES
              lcMessage = "ERROR_NO_MORE_FILES"

         CASE lnError =  ERROR_INVALID_HANDLE
              lcMessage = "ERROR_INVALID_HANDLE"

         CASE lnError =  ERROR_FILE_NOT_FOUND
              lcMessage = "ERROR_FILE_NOT_FOUND"

         CASE lnError =  ERROR_PATH_NOT_FOUND
              lcMessage = "ERROR_PATH_NOT_FOUND"

         CASE lnError =  ERROR_ACCESS_DENIED
              lcMessage = "ERROR_ACCESS_DENIED"

         CASE lnError =  ERROR_FILE_EXISTS
              lcMessage = "ERROR_FILE_EXISTS"

         CASE lnError =  ERROR_INVALID_PARAMETER
              lcMessage = "ERROR_INVALID_PARAMETER"

         OTHERWISE	
              lcMessage = "Unknown Error Message"
      ENDCASE
      RETURN lcMessage
   ENDPROC	
ENDDEFINE